/*
   (c) Copyright 2000-2002  convergence integrated media GmbH.
   All rights reserved.

   Written by Denis Oliver Kropp <dok@directfb.org>,
              Andreas Hundt <andi@fischlustig.de> and
              Sven Neumann <neo@directfb.org>.
              
   This file is subject to the terms and conditions of the MIT License:

   Permission is hereby granted, free of charge, to any person
   obtaining a copy of this software and associated documentation
   files (the "Software"), to deal in the Software without restriction,
   including without limitation the rights to use, copy, modify, merge,
   publish, distribute, sublicense, and/or sell copies of the Software,
   and to permit persons to whom the Software is furnished to do so,
   subject to the following conditions:

   The above copyright notice and this permission notice shall be
   included in all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
   IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
   CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
   TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
   SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#include <stdio.h>
#include <stdlib.h>

int
main( int argc, char *argv[] )
{
 if (argc < 5) {
          printf( "\nUsage: %s <red_start> <green_start> <blue_start> <file_to_create>\n\n", argv[0] );
          return -1;
     }
 int r = atoi(argv[1]);
 int g = atoi(argv[2]);
 int b = atoi(argv[3]);
 char *filename = argv[4];
 FILE *palette_file = fopen(filename, "w");
 
 if (palette_file==NULL)
 {
   fprintf(stderr, "File %s could not be created. Exiting!\n", filename);
   exit(1);
 }
 
 int i;
 for(i=0;i<256;i++)
    fprintf(palette_file, "%d %d %d %d\n", 0xff, (r+i)%256, (g+i)%256, (b+i)%256);
 fclose(palette_file);
 fprintf(stdout, "Palette file written succesfully!\n");
 return 0;

}
